module Expressions where

open import Cubical.Foundations.Prelude
open import Cubical.Data.Nat

-- Arithmetic expression language
data Exp : Type where
  num : ℕ → Exp
  _＋_ : Exp → Exp → Exp
  _**_ : Exp → Exp → Exp

example : Exp
example = num 1 ＋ ((num 0 ＋ (num 2 ** num 3)) ** num 7)

-- Semantics
⟦_⟧ : Exp → ℕ
⟦ e ⟧ = {!!}

test1 : ⟦ example ⟧ ≡ 43
test1 = {!!}

-- A stack machine "assembly code"
data Stack : Type where
  [] : Stack
  _∷_ : ℕ → Stack → Stack

data Instrs : Type where
  halt : Instrs
  push : ℕ → Instrs → Instrs
  add : Instrs → Instrs
  mul : Instrs → Instrs

infixr 20 _⨾_
_⨾_ : Instrs → Instrs → Instrs
halt ⨾ js = js
push x is ⨾ js = push x (is ⨾ js)
add is ⨾ js = add (is ⨾ js)
mul is ⨾ js = mul (is ⨾ js)

run : Instrs → Stack → Stack
run is s = {!!}

compile : Exp → Instrs
compile e = {!!}

correctness : ∀ e → ?
correctness e = {!!}

example-sm : Instrs
example-sm = push 6 (mul halt)

test2 : run example-sm (5 ∷ []) ≡ (30 ∷ [])
test2 = ?
